Resource = require '../Resource'
_ = require 'lodash'
q = require 'q'

describe 'Resource can', ->
	r = null
	spyGetResult = null
	spyGetRejectReason = null
	promisedResult = null
	rejectedReason = null
	spyGetPropertyDefinitionResult = null
	beforeEach ->
		spyGetResult = null
		spyGetRejectReason = null
		promisedResult = null
		rejectedReason = null
		r = new Resource
		r.getResourceFactory().addResource r
		r._get = r.get # so that spy can be removed
		spyOn(r, 'get').andCallFake (id, propertyList = null) ->
			defer = q.defer()
			if spyGetRejectReason == null
				defer.resolve spyGetResult
			else
				defer.reject spyGetRejectReason
			return defer.promise
		r._getPropertyDefinition = r.getPropertyDefinition # so that spy can be removed
		spyOn(r, 'getPropertyDefinition').andCallFake (property) ->
			return spyGetPropertyDefinitionResult
	describe ' an empty path with any resourceObj', ->
		describe ' get is nominal', ->
			beforeEach (done) ->
				spyGetResult = 'an object'
				r.navigate('', 'id param').then (result) ->
					promisedResult = result
					done()
			it ' should have passed get a resource identifier', ->
				expect(r.get.callCount).toEqual 1
				expect(r.get.mostRecentCall.args).toEqual ['id param']
			it ' should return a promise with the promised value being from get', ->
				expect(promisedResult).toEqual spyGetResult
		describe ' get rejects promise', ->
			beforeEach (done) ->
				spyGetRejectReason = 'not feeling like it'
				r.navigate('', 'id param').then null, (reason) ->
					rejectedReason = reason
					done()
			it ' should have passed get a resource identifier', ->
				expect(r.get.callCount).toEqual 1
				expect(r.get.mostRecentCall.args).toEqual ['id param']
			it ' should return a promise which is rejected', ->
				expect(rejectedReason).toEqual spyGetRejectReason
